[Документация Yandex Cloud](../../../../index.md) > [Yandex Identity Hub](../../../index.md) > Справочник API > REST (англ.) > [Identity Provider API](../index.md) > [User](index.md) > Create

# Identity Provider API, REST: User.Create

Creates a user in the specified userpool.

## HTTP request

```
POST https://organization-manager.api.yandexcloud.kz/organization-manager/v1/idp/users
```

## Body parameters {#yandex.cloud.organizationmanager.v1.idp.CreateUserRequest}

```json
{
  "userpoolId": "string",
  "username": "string",
  "fullName": "string",
  "givenName": "string",
  "familyName": "string",
  "email": "string",
  "phoneNumber": "string",
  // Includes only one of the fields `passwordSpec`, `passwordHash`
  "passwordSpec": {
    "password": "string",
    "generationProof": "string"
  },
  "passwordHash": {
    "passwordHash": "string",
    "passwordHashType": "string"
  },
  // end of the list of possible fields
  "isActive": "boolean",
  "externalId": "string",
  "companyName": "string",
  "department": "string",
  "jobTitle": "string",
  "employeeId": "string",
  "expiresAt": "string"
}
```

Request to create a new user.

#|
||Field | Description ||
|| userpoolId | **string**

Required field. ID of the userpool to create the user in.

The maximum string length in characters is 50. ||
|| username | **string**

Required field. Username for the new user.

The maximum string length in characters is 254. Value must match the regular expression ` [a-z0-9A-Z\._-]{1,64}@.{1,256} `. ||
|| fullName | **string**

Required field. Full name of the user.

The maximum string length in characters is 256. ||
|| givenName | **string**

First name of the user.

The maximum string length in characters is 256. ||
|| familyName | **string**

Last name of the user.

The maximum string length in characters is 256. ||
|| email | **string**

Email address of the user.

The maximum string length in characters is 254. Value must match the regular expression ``` |(.{3,254}) ```. ||
|| phoneNumber | **string**

Phone number of the user.

The maximum string length in characters is 50. ||
|| passwordSpec | **[PasswordSpec](#yandex.cloud.organizationmanager.v1.idp.PasswordSpec)**

Password specification. Credentials type. Exactly one of credentials type must be specified.

Includes only one of the fields `passwordSpec`, `passwordHash`.

User credentials. ||
|| passwordHash | **[PasswordHash](#yandex.cloud.organizationmanager.v1.idp.PasswordHash)**

Password hash. Credentials type. Exactly one of credentials type must be specified.

Includes only one of the fields `passwordSpec`, `passwordHash`.

User credentials. ||
|| isActive | **boolean**

Whether the user is active. Default is true. ||
|| externalId | **string**

External identifier for the user.

The maximum string length in characters is 256. ||
|| companyName | **string**

User's company name.

The maximum string length in characters is 256. ||
|| department | **string**

User's department.

The maximum string length in characters is 256. ||
|| jobTitle | **string**

User's job title.

The maximum string length in characters is 256. ||
|| employeeId | **string**

User's employee ID

The maximum string length in characters is 256. ||
|| expiresAt | **string** (date-time)

Timestamp when the user account expires.

String in [RFC3339](https://www.ietf.org/rfc/rfc3339.txt) text format. The range of possible values is from
`0001-01-01T00:00:00Z` to `9999-12-31T23:59:59.999999999Z`, i.e. from 0 to 9 digits for fractions of a second.

To work with values in this field, use the APIs described in the
[Protocol Buffers reference](https://developers.google.com/protocol-buffers/docs/reference/overview).
In some languages, built-in datetime utilities do not support nanosecond precision (9 digits). ||
|#

## PasswordSpec {#yandex.cloud.organizationmanager.v1.idp.PasswordSpec}

Password specification.

#|
||Field | Description ||
|| password | **string**

Required field. The password string.

The maximum string length in characters is 128. ||
|| generationProof | **string**

Proof that the password was generated by the system.

The maximum string length in characters is 128. ||
|#

## PasswordHash {#yandex.cloud.organizationmanager.v1.idp.PasswordHash}

Password hash information.

#|
||Field | Description ||
|| passwordHash | **string**

Required field. The password hash string.

The maximum string length in characters is 256. ||
|| passwordHashType | **enum** (PasswordHashType)

Required field. Type of the password hash.

- `AD_MD4`: Microsoft Active Directory MD4 hash.
- `LDAP_PBKDF2_SHA256`: 389 legacy format `{PBKDF2_SHA256}` (underscore).
Supported by 389 DS, FreeIPA, ALD Pro.
- `LDAP_PBKDF2_SHA256_OPENLDAP`: OpenLDAP-compatible format `{PBKDF2-SHA256}` (hyphen). Supported by 389 DS, FreeIPA, ALD Pro.
- `LDAP_PBKDF2_SHA512`: Supported by 389 DS, FreeIPA, ALD Pro.
- `LDAP_PKCS5S2`: Supported by Apache Directory Server. ||
|#

## Response {#yandex.cloud.operation.Operation}

**HTTP Code: 200 - OK**

```json
{
  "id": "string",
  "description": "string",
  "createdAt": "string",
  "createdBy": "string",
  "modifiedAt": "string",
  "done": "boolean",
  "metadata": "object",
  // Includes only one of the fields `error`, `response`
  "error": {
    "code": "integer",
    "message": "string",
    "details": [
      "object"
    ]
  },
  "response": "object"
  // end of the list of possible fields
}
```

An Operation resource. For more information, see [Operation](../../../../api-design-guide/concepts/operation.md).

#|
||Field | Description ||
|| id | **string**

ID of the operation. ||
|| description | **string**

Description of the operation. 0-256 characters long. ||
|| createdAt | **string** (date-time)

Creation timestamp.

String in [RFC3339](https://www.ietf.org/rfc/rfc3339.txt) text format. The range of possible values is from
`0001-01-01T00:00:00Z` to `9999-12-31T23:59:59.999999999Z`, i.e. from 0 to 9 digits for fractions of a second.

To work with values in this field, use the APIs described in the
[Protocol Buffers reference](https://developers.google.com/protocol-buffers/docs/reference/overview).
In some languages, built-in datetime utilities do not support nanosecond precision (9 digits). ||
|| createdBy | **string**

ID of the user or service account who initiated the operation. ||
|| modifiedAt | **string** (date-time)

The time when the Operation resource was last modified.

String in [RFC3339](https://www.ietf.org/rfc/rfc3339.txt) text format. The range of possible values is from
`0001-01-01T00:00:00Z` to `9999-12-31T23:59:59.999999999Z`, i.e. from 0 to 9 digits for fractions of a second.

To work with values in this field, use the APIs described in the
[Protocol Buffers reference](https://developers.google.com/protocol-buffers/docs/reference/overview).
In some languages, built-in datetime utilities do not support nanosecond precision (9 digits). ||
|| done | **boolean**

If the value is `false`, it means the operation is still in progress.
If `true`, the operation is completed, and either `error` or `response` is available. ||
|| metadata | **object**

Service-specific metadata associated with the operation.
It typically contains the ID of the target resource that the operation is performed on.
Any method that returns a long-running operation should document the metadata type, if any. ||
|| error | **[Status](#google.rpc.Status)**

The error result of the operation in case of failure or cancellation.

Includes only one of the fields `error`, `response`.

The operation result.
If `done == false` and there was no failure detected, neither `error` nor `response` is set.
If `done == false` and there was a failure detected, `error` is set.
If `done == true`, exactly one of `error` or `response` is set. ||
|| response | **object**

The normal response of the operation in case of success.
If the original method returns no data on success, such as Delete,
the response is [google.protobuf.Empty](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#google.protobuf.Empty).
If the original method is the standard Create/Update,
the response should be the target resource of the operation.
Any method that returns a long-running operation should document the response type, if any.

Includes only one of the fields `error`, `response`.

The operation result.
If `done == false` and there was no failure detected, neither `error` nor `response` is set.
If `done == false` and there was a failure detected, `error` is set.
If `done == true`, exactly one of `error` or `response` is set. ||
|#

## Status {#google.rpc.Status}

The error result of the operation in case of failure or cancellation.

#|
||Field | Description ||
|| code | **integer** (int32)

Error code. An enum value of [google.rpc.Code](https://github.com/googleapis/googleapis/blob/master/google/rpc/code.proto). ||
|| message | **string**

An error message. ||
|| details[] | **object**

A list of messages that carry the error details. ||
|#